import es
import gamethread
import random
import playerlib

import wcs
from wcs import wcs


info = es.AddonInfo() 
info['name']        = "Spy"
info['version']     = "1.2.9"
info['author']      = "Buldozer[FR]"
info['url']         = "http://logistique.vossey.net"
info['description'] = "Spy WCS:Python race by Buldozer[FR]"
es.ServerVar('SpyVersion',info.version,'Current WCS:Python Spy Version').makepublic()

RaceName = info.name

allowed_weapons = ('knife','usp')
wcs.Race(RaceName).registerWeaponRestriction('allow only',allowed_weapons)

wcs.Race(RaceName).registerSkill('Poison', 5, 1, 'Your attacks deal extra damage over time.')
wcs.Race(RaceName).registerSkill('Assassin', 5, 1,'Extra knife damage.')
wcs.Race(RaceName).registerSkill('Evasion', 6, 2, 'Have a chance to dodge damage from an attack.')
wcs.Race(RaceName).registerSkill('Speed', 6, 2, 'Move faster you to surprise your enemies, or simply flee.')
wcs.Race(RaceName).registerSkill('Hide', 6, 5, 'You become hard to see when standing still.')
wcs.Race(RaceName).registerUltimate('Teleport', 10, 6, 5, 'Use your ultimate to teleport to the position you are looking at.')
wcs.Race(RaceName).registerMinLevel(65)

def player_spawn(event_var):
	userid = int(event_var['userid'])
	wcs.Command(userid).UpdateDict('poisoned',0)
	if wcs.GetRace(userid) == RaceName and es.getplayerteam(userid) != 0 and es.getplayerteam(userid) != 1:
		es.server.queuecmd('es_xgive %s %s' % (userid, 'weapon_knife'))
		es.server.queuecmd('es_xgive %s %s' % (userid, 'weapon_usp'))
		speed = wcs.GetLevel(userid,RaceName,'Speed')
		if speed:
			speed = speed / float(15)
			wcs.Command(userid).Speed(speed + 1)
			es.tell(userid,'#multi','#lightgreenSpeed #default- #greenYou have gained a %.0f%% speed boost.'%(speed*100))
		hide = wcs.GetLevel(userid, RaceName, 'Hide') 
		if hide:
			wcs.Command(userid).UpdateDict('hidden',0)
			wcs.Command(userid).UpdateDict('location', es.getplayerlocation(userid))
			hide_loop(userid,30/hide)
			
def player_hurt(event_var):
	userid = int(event_var['userid'])
	attacker = int(event_var['attacker'])
	weapon = event_var['es_attackerweapon']
	if weapon == "weapon_knife":
		assassin = wcs.GetLevel(attacker,RaceName,"Assassin") * 10
		if assassin:
			wcs.Command(userid).Damage(assassin,2,attacker)
	elif weapon == "weapon_usp":
		poison = wcs.GetLevel(attacker,RaceName,'Poison')
		if poison:
			if not wcs.Command(userid).ReturnDict('poisoned'):
				wcs.Command(userid).UpdateDict('poisoned',1)
				wcs.Command(userid).SpeedAdd(-.3)
				gamethread.delayed(2,wcs.Command(userid).Damage,(poison,32,attacker))
				gamethread.delayed(4,wcs.Command(userid).Damage,(poison,32,attacker))
				gamethread.delayed(6,wcs.Command(userid).Damage,(poison,32,attacker))
				gamethread.delayed(8,wcs.Command(userid).Damage,(poison,32,attacker))
				gamethread.delayed(10,wcs.Command(userid).Damage,(poison,32,attacker))
				gamethread.delayed(10,wcs.Command(userid).SpeedAdd,.3)
				gamethread.delayed(10,wcs.Command(userid).UpdateDict,('poisoned',0))
				es.tell(userid, '#multi', '#lightgreenPoison #default- #greenYou are poisoned by %s.'%(es.getplayername(attacker)))
				es.tell(attacker, '#multi', '#lightgreenPoison #default- #greenYou have poisoned %s.'%(es.getplayername(userid)))

def prep_hurt(event_var):
	userid = int(event_var['userid'])
	attacker = int(event_var['attacker'])
	if attacker:
		damage = int(event_var['dmg_health'])
		evasion = wcs.GetLevel(userid, RaceName, 'Evasion') * 10
		if evasion:
			if evasion >= random.randint(1,100):
				wcs.Command(userid).SaveLife(damage)
				es.tell(userid, '#multi', '#lightgreenEvasion #default- #greenYou have dodged %s damage from an attack.'%damage)

def hide_loop(userid,al):
	if es.exists('userid', userid) and not playerlib.getPlayer(userid).get('isdead'):
		location = es.getplayerlocation(userid)
		if location == wcs.Command(userid).ReturnDict('location'):
			if not wcs.Command(userid).ReturnDict('hidden'):
				wcs.Command(userid).UpdateDict('hidden',1)
				wcs.Command(userid).Fade(al, 1)
		else:
			wcs.Command(userid).UpdateDict('hidden',0)
			wcs.Command(userid).UpdateDict('location', location)
			wcs.Command(userid).Color(alpha=255)
		gamethread.delayed(1, hide_loop, (userid,al))
	else:
		wcs.Command(userid).UpdateDict('hidden',0)

def player_ultimate_on(event_var):
	userid = int(event_var['userid'])
	teleport_level = wcs.GetLevel(userid, RaceName, 'Teleport')
	if teleport_level:
		wcs.Command(userid).GetViewCoord(teleport)
		wcs.Command(userid).SetCoolDown('Teleport',30/teleport_level)

def teleport(userid, x, y, z):
	z = str(float(z)+15)
	wcs.Effect().Smoke(userid)
	es.server.queuecmd('es_xsetpos %s %s %s %s'%(userid, x, y, z))
	wcs.Effect().Smoke(userid)
	